Subject: Re: bug#65797: 29.0.92; func-arity should not return (0 . many) with apply-partially

From: Stefan Monnier <[email-masked]>
Date: Tue, 12 Sep 2023 14:30:45 -0400

>> So some backward-incompatibility is inevitable, unless we decide to
>> stick to the current code to be "bug compatible" :-(
> I think one of the alternatives you proposed was backward-compatible
> (albeit not very elegant).  So my vote is for that alternative.

I'd first want to decide which semantics we want to document.
We could keep the current semantics, but since we're unable to implement it
reliably I'd rather we change it.

After that we can decide on how to preserve backward compatibility (for
which it would be OK to rely on a hack like the current one).

Maybe the simplest change is to align the Texinfo doc with the docstring
(i.e. document that two args are passed, always) and keep the code as
is.  And maybe tweak the code so it emits a warning when

    (eq 1 (cdr (func-arity condition)))

is true.

        Stefan